#include <stdio.h>
#define nodos 4
#define infinito 999

extern int TRACE;
extern int YES;
extern int NO;
extern float clocktime;
extern int connectcosts[nodos][nodos];

extern struct rtpkt

 {
  int sourceid;       /* id of sending router sending this pkt */
  int destid;         /* id of router to which pkt being sent 
                         (must be an immediate neighbor) */
  int contador;
  int mincost[nodos];    /* min cost to node 0 ... 3 */
  } a;

struct distance_table 
{
  int costs[nodos][nodos];
} dt1;


/* students to write the following two routines, and maybe some others */
int min_distancia1[nodos]={infinito,infinito,infinito,infinito};

int calcula_min1()
{
	int dest, via, cambio = 0;
	int mini[4];

	for (dest=0; dest<4; dest++) {
		mini[dest] = dt1.costs[dest][0];
		for (via=1; via<4; via++) {
			if (mini[dest] > dt1.costs[dest][via])
				mini[dest] = dt1.costs[dest][via];
		}
		if (mini[dest] != min_distancia1[dest]) {
			min_distancia1[dest] = mini[dest];
			cambio =1;
		}
	}
	return cambio;
}


void envia_vecinos1()
{
	int dest;
	struct rtpkt packet;
	packet.sourceid = 1;	
	for (dest=0; dest<4; dest++) 
		packet.mincost[dest] = min_distancia1[dest];
	packet.destid=0;
	tolayer2(packet);
	printf("En el tiempo t=%.3f, nodo 1 envia paquete al nodo 0 con: %d %d %d %d\n",
		clocktime, packet.mincost[0], packet.mincost[1], packet.mincost[2],packet.mincost[3]);
	packet.destid=2;
	tolayer2(packet);
	printf("En el tiempo t=%.3f, nodo 1 envia paquete al nodo 2 con: %d %d %d %d\n",
		clocktime, packet.mincost[0], packet.mincost[1], packet.mincost[2],packet.mincost[3]);
	printf("\n");

}

void rtinit1(void) 
{
	int dest,via;
	printf("En el tiempo t=%.3f, rtinit1() es llamado \n", clocktime);


	for (dest=0; dest<4; dest++)
		for (via=0; via<4; via++) {
			if (dest==via) 	dt1.costs[dest][via] = connectcosts[1][dest];
			else		dt1.costs[dest][via] = infinito;
		}
	for (dest=0; dest<4; dest++) 		
		min_distancia1[dest]=connectcosts[1][dest];
	printdt1(&dt1);         
	tolayer2();
	envia_vecinos1();
}


void rtupdate1(rcvdpkt)
  struct rtpkt *rcvdpkt;
{
	int dest,via;
	via=rcvdpkt->sourceid;

	printf("En el tiempo t=%.3f, rtupdate1() es llamado. Nodo 1 recibe paquete del nodo %d\n",clocktime, via);

	
	for ( dest= 0; dest<4; dest++) {
		dt1.costs[dest][via] = connectcosts[1][via] + rcvdpkt->mincost[dest];
		if (dt1.costs[dest][via] > infinito)
			dt1.costs[dest][via]= infinito;
	}

	printdt1(&dt1);				
	if (calcula_min1() == 1)	envia_vecinos1();

}


printdt1(dtptr)
  struct distance_table *dtptr;
  
{
  printf("                via     \n");
  printf("   D1 |    0     2     3 \n");
  printf("  ----|----------------------------- \n");
  printf("     0|  %3d   %3d   %3d \n",dtptr->costs[0][0],
	 dtptr->costs[0][2],dtptr->costs[0][3]);
  printf("dest 2|  %3d   %3d   %3d \n",dtptr->costs[2][0],
	 dtptr->costs[2][2],dtptr->costs[2][3]);
  printf("     3|  %3d   %3d   %3d \n",dtptr->costs[3][0],
	 dtptr->costs[3][2],dtptr->costs[3][3]);

}

linkhandler1(linkid, newcost)   
int linkid, newcost;
	
{
	int oldcost=connectcosts[1][linkid],dest;	
	printf("En el tiempo t=%.3f, linkhandler0() es llamado \n", clocktime);
	connectcosts[1][linkid] = newcost;

	for (dest=0; dest<4; dest++) {
		dt1.costs[dest][linkid] = dt1.costs[dest][linkid] - oldcost + newcost;
		if (dt1.costs[dest][linkid] > infinito)
			dt1.costs[dest][linkid] = infinito;
	}

	printdt1(&dt1);			
	if (calcula_min1()==1)	
		envia_vecinos1();


}
